function u_ff =feedforwardalgotithm(u)

%feedforward algotithm
%Yngvild Aurlien

a_MRU=u(1);
pos_cyl=u(4);
v_cyl=u(5);



global e Friction a_ds v_ds x_ds v_c pos_c a_b v_b x_b timestep zero_velocity f_cl F_d F_s M_dyn D k M_CR F_ds F_W a_c i velocity;
global D_CR A_CR A_AA A_A A_p DeltaP M_AA M_d beta Vi1 Vi2 f_valve B_p F_AA F_A F_c F_control a_a v_a pos_a e_a DeltaFP DeltaP_control P1_init P1 P1_next P1_der Q;
global v_f x_f K_v e_v K_f F_b F_heave;
global P_N f_valves DeltaP V_i F_pipes;





%a posteriori update for currert timestep

e_pos=pos_c-pos_cyl;
e_vel=v_cyl-v_c;
v_c=v_c-0.1*e_pos;
pos_c=pos_c-0.08*e_pos;
F_d=F_d+48.0*e_pos;

F_heave=M_CR*a_MRU;

if abs(F_heave)<F_s
    F_static=F_heave*sign(F_heave);
else
    F_static=F_s*sign(F_heave);
end

%sylinder
if abs(v_c) < 0.05 %static friction
    
    a_c=(F_heave-0.5*F_b-f_cl*v_c-F_pipes-F_static-Friction)/M_CR;
   
else
   
    a_c=(F_heave-0.5*F_b-f_cl*v_c-F_pipes-F_d*sign(v_c)-Friction)/M_CR;
    
end


F_c=a_c*M_CR;

%rr og ventiler
F_pipes=(A_p/A_CR)*((DeltaP*A_p+4*f_valve*A_p*A_p^2)*abs(v_c*A_CR/A_p)*(v_c*A_CR/A_p));


if abs(v_c) < 0.05 %static friction
    Friction=-F_static-f_cl*v_c-F_pipes;
    F_b=2*(F_c+0.5*F_b-F_heave)-k*x_b-D*v_b;

else
    Friction=-F_d*sign(v_c)-f_cl*v_c-F_pipes; %dry friction
    F_b=-k*x_b-D*v_b;

end

%a priori estimates for next timestep

v_c=v_c+a_c*timestep;

pos_c=pos_c+v_c*timestep;


a_b=F_b/M_dyn;

v_b=v_b+a_b*timestep;
x_b=x_b+v_b*timestep;


F_AA=F_c*A_CR/A_A;

%Active accumulator

a_a=(-F_AA-F_control)/M_AA;

F_A=a_a*M_AA;

v_a=v_a+a_a*timestep;
pos_a=pos_a+v_a*timestep;


%Calculation of control force
F_control=-Friction*A_CR/A_A;

u_ff=zeros(1,1);

u_ff(1)=F_control;
u_ff(2)=e_vel;
u_ff(3)=e_pos;
u_ff(4)=F_d;