%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%plotsAF.m
%
%this file makes plots for the acceleration feedback  algorithm
%Yngvild Aurlien
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(2,2,1);
plot(vel_c.time,vel_c.signals.values);
title('Hastighet til hovedsylinder');
xlabel('Time (s)');
ylabel('Hastighet (m/s)');
grid

subplot(2,2,2);
plot(x_c.time,x_c.signals.values);
title('Posisjon til hovedsylinder');
xlabel('Time (s)');
ylabel('Posisjon (m)');
grid

subplot(2,2,3);
plot(F_contr.time,F_contr.signals.values);
title('Pdragskraft i aktiv akkumulator');
xlabel('Time (s)');
ylabel('Kraft(N)');
grid

subplot(2,2,4);
plot(F_C.time,F_C.signals.values);
title('Summen av kreftene til hovedsylinderen');
xlabel('Time (s)');
ylabel('Kraft(N)');

figure
subplot(2,1,1)
plot(NCF.time,NCF.signals.values);
title('Ukompensert friksjon i sylinderen');
xlabel('Time (s)');
ylabel('Kraft (N)');
grid

subplot(2,1,2)
plot(dWOB.time,dWOB.signals.values);
title('Variasjon i WOB');
xlabel('Time (s)');
ylabel('Kraft (N)');
grid


